<?php

class Device extends CActiveRecord {
    
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }
    
    public function tableName() {
        return "devices";
    }
    
    public function attributeLabels() {
        return array(
            "device_type_id" => "Device Categories",
            "device_name" => "Name",
            "device_brand_name" => "Manufacturer",
            "device_code" => "Code",
            "device_record_code" => "Asset Code",
            "device_price" => "Price",
            "device_created_date" => "Created",
            "device_buy_date" => "Brought",
            "device_garantee_expire_date" => "Guarantee expired"
        );
    }
    
    public function beforeValidate() {
        if ($this->isNewRecord) {
            $this->device_created_date = new CDbExpression("NOW()");
        }
        
        return parent::beforeValidate();
    }
    
    public function relations() {
        return array(
            "device_type" => array(self::BELONGS_TO, "DeviceType", "device_type_id")
        );
    }
    
    public function search() {
        $criteria = new CDbCriteria;
        return new CActiveDataProvider($this, array(
                    'criteria' => $criteria,
                ));
    }
    
    public static function getOptions() {
        $devices = Device::model()->findAll();
        $arr = array();
        
        foreach ($devices as $r) {
            $arr[$r->id] = $r->device_brand_name." ".$r->device_name;
        }
        return $arr;
    }
    
}